# Visa Direct Account and Wallet
Visa Direct Account and Wallet

## Version: 1

### Servers

| URL | Description |
| --- | ----------- |
| https://sandbox.api.visa.com | Sandbox server |

---
### Webhooks

### [POST] /v3/payouts/statusNotification
**Payout Status Notification**

The purpose of the API is to Enable Visa to provide updates of an pay to account or pay to wallet or pay to card transaction to originator

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"payoutMethod"**: <br>**Available values:** "B", "W", **"transactionDetail"**: { **"status"**: <br>**Available values:** "PAYMENT_RECEIVED", **"payoutId"**: , **"endToEndId"**: , **"payoutSpeed"**: <br>**Available values:** "STANDARD", "PREMIUM", **"fxConversionRate"**: undefined (double), **"settlementAmount"**: undefined (double), **"clientReferenceId"**: , **"destinationAmount"**: undefined (double), **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"expectedPostingDate"**: undefined (date), **"transactionDateTime"**: undefined (date-time), **"notificationDateTime"**: undefined (date-time), **"settlementCurrencyCode"**: , **"destinationCurrencyCode"**: , **"transactionCurrencyCode"**:  } } or { **"payoutMethod"**: <br>**Available values:** "B", "W", **"transactionDetail"**: { **"status"**: <br>**Available values:** "PAYMENT_RECEIVED", "AWAITING_INFORMATION", "PAYMENT_SENT", "PAYMENT_DELIVERED", "DELIVERED_TO_SCHEME", "DELIVERED_TO_RECIPIENT_BANK", **"payoutId"**: , **"endToEndId"**: , **"fundingStatus"**: <br>**Available values:** "FUNDED", "NOT_FUNDED", "FUNDED_AGING", **"serviceDetail"**: { **"traceable"**: , **"recallable"**: , **"paymentRail"**: <br>**Available values:** "ACH", "RTP", "RTGS", "SWIFT", **"isFinalStatus"**:  }, **"clientReferenceId"**: , **"deliveredDateTime"**: undefined (date-time), **"initiatingPartyId"**: undefined (int64), **"expectedPostingDate"**: undefined (date), **"notificationDateTime"**: undefined (date-time), **"walletAdditionalDetails"**: { **"shareLink"**:  }, **"localSchemeTransactionId"**:  } } or { **"payoutMethod"**: <br>**Available values:** "B", "W", **"transactionDetail"**: { **"status"**: <br>**Available values:** "VALIDATION_FAILED", "ERROR", **"errorResponses"**: , **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64), **"notificationDateTime"**: undefined (date-time) } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok |  |
| 400 | When any field fails schematic validation or when any required field is missing or when request is inconsistent with the Request definitions. | **application/json**: { **"errorResponse"**: { **"reason"**: , **"status"**: , **"details"**: , **"message"**:  } }<br> |
| 404 | Resource not found |  |
| 503 | Service Unavailable |  |

---
### Schemas

#### EventNotification Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutId |  | This is a unique identifier generated by the Visa for a transaction and is key field used in the subsequent messages with in the transaction set example Notification, Returns, Cancel, Exception management via VD Portal for Payout  ISO20022 field name: Transaction Information And Status - Original Additional Remittance Information  | Yes |
| eventType | <br>**Available values:** "PENDING_NETWORK_REVIEW", "NETWORK_REVIEW_CLOSED" | Possible events on a transaction - PENDING_NETWORK_REVIEW: The payout is currently under review at Network Partner. - NETWORK_REVIEW_CLOSED: The Network Partner review is now closed. Refer to payout status for additional information. <br>*Enum:* `"PENDING_NETWORK_REVIEW"`, `"NETWORK_REVIEW_CLOSED"`<br>*Example:* `"PENDING_NETWORK_REVIEW"` | Yes |
| initiatingPartyId | undefined (int64) | Identifier assigned by Visa to uniquely identify the Originating Entity who initiates the transaction  ISO20022 field name: Initiating Party Identification<br> Visa uses integer instead of string(1-35) for uniformed value generation and presentation. <br>*Example:* `100111` | Yes |

#### SignedAmount-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| SignedAmount-1 | double |  |  |

**Example**
<pre>12.34</pre>

#### AlphaCountryCode Schema

3-character ISO-3166 (Alpha-3) country code.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| AlphaCountryCode |  | 3-character ISO-3166 (Alpha-3) country code. |  |

**Example**
<pre>USA</pre>

#### PayoutNotificationReceivedRequest-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | string, <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. Account or Wallet  Valid values: - "B" Visa Direct Account - "W" Visa Direct Wallet <br>*Enum:* `"B"`, `"W"` | No |
| transactionDetail | { **"status"**: string, **"payoutId"**: string, **"endToEndId"**: string, **"payoutSpeed"**: string, <br>**Available values:** "STANDARD", "PREMIUM", **"fxConversionRate"**: double, **"settlementAmount"**: double, **"clientReferenceId"**: string, **"destinationAmount"**: double, **"initiatingPartyId"**: long, **"transactionAmount"**: double, **"expectedPostingDate"**: undefined (date), **"transactionDateTime"**: dateTime, **"notificationDateTime"**: dateTime, **"settlementCurrencyCode"**: string, **"destinationCurrencyCode"**: string, **"transactionCurrencyCode"**: string } |  | Yes |

#### WalletPayoutRequest Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"quoteId"**: undefined (int64), **"endToEndId"**: , **"payoutSpeed"**: <br>**Available values:** "STANDARD", "PREMIUM", **"fundingModel"**: <br>**Available values:** "PREFUNDED", **"additionalData"**: , **"purposeOfPayment"**: , **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"statementNarrative"**: , **"senderSourceOfFunds"**: , **"businessApplicationId"**: , **"settlementCurrencyCode"**: , **"transactionCurrencyCode"**: , **"senderBeneficiaryRelationship"**:  } |  | Yes |

#### TotalAmountDue Schema

Total amount due by due date.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TotalAmountDue | undefined (double) | Total amount due by due date. |  |

#### FlexibleAmountRemaining Schema

Remaining amount of liquidity available.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| FlexibleAmountRemaining | undefined (double) | Remaining amount of liquidity available. |  |

#### PayoutDigitalAssetRequestAltered Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | <br>**Available values:** "D" | This field indicates the payout method i.e. Digital Asset Valid values: - "D" Visa Direct Digital Asset <br>*Enum:* `"D"` | No |
| senderDetail | { **"type"**: <br>**Available values:** "I", "C", **"lastName"**: , **"firstName"**:  } or { **"name"**: , **"type"**: <br>**Available values:** "I", "C" } |  | Yes |
| recipientDetail | { **"type"**: <br>**Available values:** "I", "C", **"address"**: { **"city"**: , **"state"**: , **"country"**: , **"postalCode"**: , **"addressLine1"**: , **"addressLine2"**:  }, **"lastName"**: , **"firstName"**: , **"dateOfBirth"**: undefined (date), **"identificationList"**:  } or { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"address"**: { **"city"**: , **"state"**: , **"country"**: , **"postalCode"**: , **"addressLine1"**: , **"addressLine2"**:  }, **"identificationList"**:  } |  | Yes |

#### WalletQueryPendingOnlyCancelledResponse-1 Schema

Transaction is in pending or cancelled (cancelled during pending) status.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | string, <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. Account or Wallet  Valid values: - "B" Visa Direct Account - "W" Visa Direct Wallet <br>*Enum:* `"B"`, `"W"` | No |
| transactionDetail | { **"status"**: string, <br>**Available values:** "PENDING", "PENDING_CANCELLATION", "CANCELLED", **"clientReferenceId"**: string, **"initiatingPartyId"**: long } |  | Yes |

#### PayoutWalletRequest-3 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | string, <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. To Account or Wallet  Valid values: “W” – Visa Direct Wallet  | Yes |
| senderDetail | { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"lastName"**: string, **"firstName"**: string, **"cityOfBirth"**: string, **"dateOfBirth"**: date, **"countryOfBirth"**: string } or { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C" } |  | Yes |
| recipientDetail | { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"address"**: { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string }, **"lastName"**: string, **"firstName"**: string, **"cityOfBirth"**: string, **"dateOfBirth"**: date, **"countryOfBirth"**: string } or { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"address"**: { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string } } |  | Yes |

#### WalletQueryPendingOnlyCancelledResponse-2 Schema

Transaction is in pending or cancelled (cancelled during pending) status.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. Account or Wallet  Valid values: - "B" Visa Direct Account - "W" Visa Direct Wallet <br>*Enum:* `"B"`, `"W"` | No |
| transactionDetail | { **"status"**: <br>**Available values:** "PENDING", "PENDING_CANCELLATION", "CANCELLED", **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64) } |  | Yes |

#### PayoutWalletRequest-4 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | string, <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. To Account or Wallet  Valid values: “W” – Visa Direct Wallet  | Yes |
| senderDetail | { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"lastName"**: string, **"firstName"**: string, **"cityOfBirth"**: string, **"dateOfBirth"**: date, **"countryOfBirth"**: string } or { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C" } |  | Yes |
| recipientDetail | { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"address"**: { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string }, **"lastName"**: string, **"firstName"**: string, **"cityOfBirth"**: string, **"dateOfBirth"**: date, **"countryOfBirth"**: string } or { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"address"**: { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string } } |  | Yes |

#### PayoutWalletRequest-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | string, <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. To Account or Wallet  Valid values: “W” – Visa Direct Wallet  | Yes |
| senderDetail | { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"lastName"**: string, **"firstName"**: string, **"cityOfBirth"**: string, **"dateOfBirth"**: date, **"countryOfBirth"**: string, **"identificationList"**: [ { **"idType"**: string, <br>**Available values:** "P", "D", "N", "T", "F", **"idNumber"**: string, **"idIssueCountry"**: string } ] } or { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"identificationList"**: [ { **"idType"**: string, <br>**Available values:** "T", "L", **"idNumber"**: string, **"idIssueCountry"**: string } ] } |  | Yes |
| recipientDetail | { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"address"**: { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string }, **"lastName"**: string, **"firstName"**: string, **"cityOfBirth"**: string, **"dateOfBirth"**: date, **"countryOfBirth"**: string, **"identificationList"**: [ { **"idType"**: string, <br>**Available values:** "P", "D", "N", "T", "F", **"idNumber"**: string, **"idIssueCountry"**: string } ] } or { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"address"**: { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string }, **"identificationList"**: [ { **"idType"**: string, <br>**Available values:** "T", "L", **"idNumber"**: string, **"idIssueCountry"**: string } ] } |  | Yes |

#### PayoutWalletRequest-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. To Account or Wallet  Valid values: “W” – Visa Direct Wallet  | Yes |
| senderDetail | { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"lastName"**: , **"firstName"**: , **"cityOfBirth"**: , **"dateOfBirth"**: undefined (date), **"countryOfBirth"**: , **"identificationList"**:  } or { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"identificationList"**:  } |  | Yes |
| recipientDetail | { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"address"**: { **"city"**: , **"state"**: , **"country"**: , **"postalCode"**: , **"addressLine1"**: , **"addressLine2"**:  }, **"lastName"**: , **"firstName"**: , **"cityOfBirth"**: , **"dateOfBirth"**: undefined (date), **"countryOfBirth"**: , **"identificationList"**:  } or { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"address"**: { **"city"**: , **"state"**: , **"country"**: , **"postalCode"**: , **"addressLine1"**: , **"addressLine2"**:  }, **"identificationList"**:  } |  | Yes |

#### PayoutSpeed Schema

Originating Entity to indicate the desired payout speed for the payment. Currently supported value is "STANDARD". This field will be enhanced in future to include additional speed options

ISO20022 field name: Instruction Priority

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| PayoutSpeed | <br>**Available values:** "STANDARD", "PREMIUM" | Originating Entity to indicate the desired payout speed for the payment. Currently supported value is "STANDARD". This field will be enhanced in future to include additional speed options  ISO20022 field name: Instruction Priority  |  |

**Example**
<pre>standard</pre>

#### RecipientAdditionalData Schema

Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value)

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| RecipientAdditionalData |  | Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value) |  |

#### ValidatePayoutWalletOnlyRequest Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"quoteId"**: undefined (int64), **"endToEndId"**: , **"payoutSpeed"**: <br>**Available values:** "STANDARD", "PREMIUM", **"fundingModel"**: <br>**Available values:** "PREFUNDED", **"additionalData"**: , **"purposeOfPayment"**: , **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"statementNarrative"**: , **"senderSourceOfFunds"**: , **"businessApplicationId"**: , **"settlementCurrencyCode"**: , **"transactionCurrencyCode"**: , **"senderBeneficiaryRelationship"**:  } |  | Yes |

#### NotificationsErrorResponse-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| reason | string | The short description of the error. | No |
| status | integer | 3 digit HTTP status code<br>*Example:* `400` | No |
| details | [ { **"code"**: string, **"message"**: string, **"location"**: string } ] | Reserved for future use. | No |
| message | string | The long description of the error | No |

#### TotalAmountOverdueSettlementDueBreached Schema

Total amount currently overdue. This represents only the amounts that have actually breached their due date/time, excluding any future-dated amounts that are not yet due.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TotalAmountOverdueSettlementDueBreached | undefined (double) | Total amount currently overdue. This represents only the amounts that have actually breached their due date/time, excluding any future-dated amounts that are not yet due.  |  |

#### FieldValue Schema

Is used to create a select list within a User Interface for the 'additionalFieldWithValues' data field.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| label | string | List item label. | No |
| option | string | List option value. | No |

#### IndividualRecipientIdentificationListAccount Schema

Identification list of recipient

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| IndividualRecipientIdentificationListAccount |  | Identification list of recipient |  |

#### FirstName-1 Schema

Required when recipient is an individual.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| FirstName-1 | string | Required when recipient is an individual. |  |

**Example**
<pre>Joe</pre>

#### IdType-1 Schema

When present, this field contains the type of identification document.

Valid values:
* `P` - Passport
* `D` - Driving License
* `N` - National Id
* `T` - Tax Id
* `L` - Legal Entity Registration Number
* `F` - Foreign Id

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| IdType-1 | string, <br>**Available values:** "P", "D", "N", "T", "L", "F" | When present, this field contains the type of identification document.  Valid values: * `P` - Passport * `D` - Driving License * `N` - National Id * `T` - Tax Id * `L` - Legal Entity Registration Number * `F` - Foreign Id  |  |

**Example**
<pre>P</pre>

#### DigitalAssetRecipientIsCompany Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name |  | Recipient company name. <br>Must not contain exclusively numeric characters  ISO20022 field name: Creditor Name  | Yes |
| type | <br>**Available values:** "I", "C" | Identifies the type of recipient - "C" for Company   | Yes |
| address | { **"city"**: , **"state"**: , **"country"**: , **"postalCode"**: , **"addressLine1"**: , **"addressLine2"**:  } |  | Yes |
| identificationList |  |  | Yes |

#### FundingDetails-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| currencyCode |  | 3-character ISO-4217 (Alpha-3) currency code <br>*Example:* `"USD"` | Yes |
| totalAmountDue | undefined (double) | Total amount due by due date. Pulled in this request.  | Yes |
| pullFundsDetails | { **"iBan"**: , **"bankName"**: , **"accountNumber"**: , **"expectedDebitDateTime"**: undefined (date-time) } |  | No |

#### FundingDetails-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| currencyCode | string | 3-character ISO-4217 (Alpha-3) currency code <br>*Example:* `"USD"` | Yes |
| totalAmountDue | double | Total amount due by due date. Pulled in this request.  | Yes |
| pullFundsDetails | { **"iBan"**: string, **"bankName"**: string, **"accountNumber"**: integer, **"expectedDebitDateTime"**: dateTime } |  | No |

#### RecipientCompany-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name | string | Recipient company name. <br>Must not contain exclusively numeric characters  ISO20022 field name: Creditor Name  | Yes |
| type | string, <br>**Available values:** "I", "C" | Identifies the type of recipient - "C" for Company   | Yes |
| address | { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string } |  | No |

#### TransactionIdType-1 Schema

This field indicates the type of identifier
- CLIENT_REFERENCE_ID is merchant's transaction reference ID
- PAYOUT_ID is Visa's transaction reference ID

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TransactionIdType-1 | string, <br>**Available values:** "CLIENT_REFERENCE_ID", "PAYOUT_ID" | This field indicates the type of identifier - CLIENT_REFERENCE_ID is merchant's transaction reference ID - PAYOUT_ID is Visa's transaction reference ID  |  |

#### WalletVerifyResponse-2 Schema

This object is only present if verificationStatus is COMPLETED

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| verificationId |  | Unique verification identifier.<br>*Example:* `"5003f6a0-2c44-11b2-aa57-47378ae53313"` | Yes |
| verificationStatus | <br>**Available values:** "COMPLETED", "NOT_COMPLETED" | Provides the status of verification request. * COMPLETED - Request was completed and result is available. * NOT_COMPLETED - Wallet Partner's end wallet operator or Wallet Operator not available. <br>*Enum:* `"COMPLETED"`, `"NOT_COMPLETED"`<br>*Example:* `"COMPLETED"` | Yes |
| walletVerificationDetail | { **"nameMatch"**: <br>**Available values:** "STRONG_MATCH", "NO_MATCH", "NOT_SUPPORTED", **"accountIdentifierMatch"**:  } |  | No |
| clientVerificationReference |  | A client submitted identifier. This field and same value will be returned in the response.<br>*Example:* `"1234567890"` | No |

#### VerifyRecipientWalletOnlyRequest-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | <br>**Available values:** "W" | Originating Entity must indicate the payout method i.e. Wallet Valid values: - "W" Visa Direct Wallet <br>*Enum:* `"W"` | No |
| recipientDetail | { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"wallet"**: { **"countryCode"**: , **"currencyCode"**: , **"operatorName"**: , **"accountIdentifier"**: , **"accountIdentifierType"**: <br>**Available values:** "PHONENUMBER", "EMAIL", "USERNAME" }, **"lastName"**: , **"firstName"**:  } |  | Yes |
| initiatingPartyId | undefined (int64) | Identifier assigned by Visa to uniquely identify the Originating Entity who initiates the transaction  ISO20022 field name: Initiating Party Identification<br> Visa uses integer instead of string(1-35) for uniformed value generation and presentation. <br>*Example:* `100111` | Yes |
| clientVerificationReference |  | A client submitted identifier. This field and same value will be returned in the response.<br>*Example:* `"1234567890"` | No |

#### ReturnReasonCode Schema

If the Transaction Status is RETURNED or REJECTED then Return reason code will be populated

ISO20022 field name: Payment Return - Reason Code  

For a complete list of reject/return codes and descriptions please visit <a href='/capabilities/visa-direct-account-and-wallet/docs-error-codes'>Visa Direct Account and Wallet - Error Codes</a>

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| ReturnReasonCode |  | If the Transaction Status is RETURNED or REJECTED then Return reason code will be populated  ISO20022 field name: Payment Return - Reason Code    For a complete list of reject/return codes and descriptions please visit <a href='/capabilities/visa-direct-account-and-wallet/docs-error-codes'>Visa Direct Account and Wallet - Error Codes</a>  |  |

**Example**
<pre>RE303</pre>

#### WalletVerifyResponse-1 Schema

This object is only present if verificationStatus is COMPLETED

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| verificationId | string | Unique verification identifier.<br>*Example:* `"5003f6a0-2c44-11b2-aa57-47378ae53313"` | Yes |
| verificationStatus | string, <br>**Available values:** "COMPLETED", "NOT_COMPLETED" | Provides the status of verification request. * COMPLETED - Request was completed and result is available. * NOT_COMPLETED - Wallet Partner's end wallet operator or Wallet Operator not available. <br>*Enum:* `"COMPLETED"`, `"NOT_COMPLETED"`<br>*Example:* `"COMPLETED"` | Yes |
| walletVerificationDetail | { **"nameMatch"**: string, <br>**Available values:** "STRONG_MATCH", "NO_MATCH", "NOT_SUPPORTED", **"accountIdentifierMatch"**: string } |  | No |
| clientVerificationReference | string |  | No |

#### VerifyRecipientWalletOnlyRequest-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | string, <br>**Available values:** "W" | Originating Entity must indicate the payout method i.e. Wallet Valid values: - "W" Visa Direct Wallet <br>*Enum:* `"W"` | No |
| recipientDetail | { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"wallet"**: { **"countryCode"**: string, **"currencyCode"**: string, **"operatorName"**: string, **"accountIdentifier"**: string, **"accountIdentifierType"**: string, <br>**Available values:** "PHONENUMBER", "EMAIL", "USERNAME" }, **"lastName"**: string, **"firstName"**: string } |  | Yes |
| initiatingPartyId | long |  | Yes |
| clientVerificationReference | string |  | No |

#### DigitalAssetPayoutResponse-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"status"**: <br>**Available values:** "PAYMENT_RECEIVED", **"payoutId"**: , **"settlementAmount"**: undefined (double), **"clientReferenceId"**: , **"destinationAmount"**: undefined (double), **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"expectedPostingDate"**: undefined (date), **"transactionDateTime"**: undefined (date-time), **"settlementCurrencyCode"**: , **"destinationCurrencyCode"**: <br>**Available values:** "USDC", **"transactionCurrencyCode"**:  } |  | Yes |

#### TransactionIdType-2 Schema

This field indicates the type of identifier
- CLIENT_REFERENCE_ID is merchant's transaction reference ID
- PAYOUT_ID is Visa's transaction reference ID 

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TransactionIdType-2 | string, <br>**Available values:** "CLIENT_REFERENCE_ID", "PAYOUT_ID" | This field indicates the type of identifier - CLIENT_REFERENCE_ID is merchant's transaction reference ID - PAYOUT_ID is Visa's transaction reference ID   |  |

#### DigitalAsset Schema

Recipient's digital asset object. 
Conditional object when payoutMethod has value 'D'

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| address |  | The crypto wallet address where funds will be sent<br>*Example:* `"0x65BFCf1a6289a0b77b4D3F7d12005a05949FD8C3"` | Yes |
| network | <br>**Available values:** "ETHEREUM", "SOLANA" | The blockchain network where the wallet operates  (e.g., ETHEREUM, SOLANA) <br>*Enum:* `"ETHEREUM"`, `"SOLANA"`<br>*Example:* `"SOLANA"` | Yes |
| currencyCode | <br>**Available values:** "USDC" | The cryptocurrency or fiat currency code<br>*Enum:* `"USDC"`<br>*Example:* `"USDC"` | Yes |

#### DigitalAssetPayoutResponse-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"status"**: string, <br>**Available values:** "PAYMENT_RECEIVED", **"payoutId"**: string, **"settlementAmount"**: double, **"clientReferenceId"**: string, **"destinationAmount"**: double, **"initiatingPartyId"**: long, **"transactionAmount"**: double, **"expectedPostingDate"**: undefined (date), **"transactionDateTime"**: dateTime, **"settlementCurrencyCode"**: string, **"destinationCurrencyCode"**: string or string, <br>**Available values:** "USDC", **"transactionCurrencyCode"**: string } |  | Yes |

#### WalletRecipientIsCompany-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name | string | Recipient company name. <br>Must not contain exclusively numeric characters  ISO20022 field name: Creditor Name  | Yes |
| type | string, <br>**Available values:** "I", "C" | Identifies the type of recipient - "C" for Company   | Yes |
| address | { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string } |  | No |
| identificationList | [ { **"idType"**: string, <br>**Available values:** "T", "L", **"idNumber"**: string, **"idIssueCountry"**: string } ] |  | No |

#### AdditionalDataValue-1 Schema

Value of the field.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| AdditionalDataValue-1 | string | Value of the field. |  |

#### WalletSenderTransactorDetailWithID Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| WalletSenderTransactorDetailWithID | { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"lastName"**: , **"firstName"**: , **"cityOfBirth"**: , **"dateOfBirth"**: undefined (date), **"countryOfBirth"**: , **"identificationList"**:  } or { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"identificationList"**:  } |  |  |

#### WalletRecipientIsCompany-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name |  | Recipient company name. <br>Must not contain exclusively numeric characters  ISO20022 field name: Creditor Name  | Yes |
| type | <br>**Available values:** "I", "C" | Identifies the type of recipient - "C" for Company   | Yes |
| address | { **"city"**: , **"state"**: , **"country"**: , **"postalCode"**: , **"addressLine1"**: , **"addressLine2"**:  } |  | No |
| identificationList |  | Identification list of recipient | No |

#### City-1 Schema

When present, this field contains individual recipient's city

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| City-1 | string | When present, this field contains individual recipient's city |  |

**Example**
<pre>Santa Fe</pre>

#### VerifyRecipientDigitalAssetRequest Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | <br>**Available values:** "D" | Originating Entity must indicate the payout method i.e. Digital Asset Valid values: - "D" Visa Direct Digital Asset <br>*Enum:* `"D"` | Yes |
| recipientDetail | { **"name"**: , **"type"**: <br>**Available values:** "I", "C", **"lastName"**: , **"firstName"**: , **"digitalAsset"**: { **"address"**: , **"network"**: <br>**Available values:** "ETHEREUM", "SOLANA", **"currencyCode"**: <br>**Available values:** "USDC" } } |  | Yes |
| initiatingPartyId | undefined (int64) |  | Yes |
| clientVerificationReference |  |  | No |

#### WalletSenderIsCompany Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name |  | Sender company name. <br>Must not contain exclusively numeric characters  ISO20022 field name:<br>For 4th party payments: "Ultimate Debtor Name"<br>For 3rd party payments: "Debtor Name"  | Yes |
| type | <br>**Available values:** "I", "C" | Identifies the type of sender - "C" for Company   | Yes |
| identificationList |  | Identification list of sender | No |

#### BIC-1 Schema

Business Identifier Code (BIC) of the Sponsor FI (Acquirer)

ISO20022 field name: Debtor Agent FI BIC

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| BIC-1 | string | Business Identifier Code (BIC) of the Sponsor FI (Acquirer)  ISO20022 field name: Debtor Agent FI BIC  |  |

#### IndividualIdTypeAccount-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| IndividualIdTypeAccount-1 | string, <br>**Available values:** "P", "D", "N", "T", "F" |  |  |

#### PullFundsDetails Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| iBan |  | The IBAN, if configured.  | No |
| bankName |  | The bank name, if configured.  | No |
| accountNumber |  | The last 4 digits of the account number, if configured.  | No |
| expectedDebitDateTime | undefined (date-time) | <b>MANDATORY.</b> The date and time when the debit request will be initiated. ISO 8601 formatted UTC Timestamp, YYYY-MM-DDThh:mm:ss.sssTZD. TZD is either Z or +/-00:00  example: 2020-05-05T12:12:12.000Z, or 1997-07-16T19:20:30.45+00:00  | No |

#### Type-1 Schema

Identifies the type of sender or recipient - Individual or Company 
* I - Individual
* C - Company

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| Type-1 | string, <br>**Available values:** "I", "C" | Identifies the type of sender or recipient - Individual or Company  * I - Individual * C - Company  |  |

**Example**
<pre>I</pre>

#### SenderTransactorDetail-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| SenderTransactorDetail-1 | { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C", **"lastName"**: string, **"firstName"**: string, **"cityOfBirth"**: string, **"dateOfBirth"**: date, **"countryOfBirth"**: string } or { **"name"**: string, **"type"**: string, <br>**Available values:** "I", "C" } |  |  |

#### EndToEndId-1 Schema

Identifier assigned by the Originating Entity's customer to track the transaction end-to-end

Conditional: Required if payout to a wallet recipient

ISO20022 field name: end-to-end identification

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| EndToEndId-1 | string | Identifier assigned by the Originating Entity's customer to track the transaction end-to-end  Conditional: Required if payout to a wallet recipient  ISO20022 field name: end-to-end identification  |  |

**Example**
<pre>5003f6a02c4411b2aa5747378ae5331</pre>

#### Wallet-3 Schema

Recipient's wallet object

Conditional object when payoutMethod has value 'W'

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| countryCode | string |  | Yes |
| currencyCode | string |  | Yes |
| operatorName | string | This identifies the operator that has issued the account to the recipient and is going to receive and post the funds to the recipient’s wallet. (Refer to Payouts Endpoint Guide on list of supported Wallet Operators).  | Yes |
| accountIdentifier | string | The wallet recipient's actual account identifier associated with the wallet operator (e.g., wallet address - phone/email/username that identifies the account associated with the wallet operator)  | Yes |
| accountIdentifierType | string, <br>**Available values:** "PHONENUMBER", "EMAIL", "USERNAME" | The type of account identifier used by the recipient.   Supported values are PHONENUMBER, EMAIL and USERNAME.           <br>*Enum:* `"PHONENUMBER"`, `"EMAIL"`, `"USERNAME"`<br>*Example:* `"PHONENUMBER"` | Yes |

#### Wallet-2 Schema

Recipient's wallet object

Conditional object when payoutMethod has value 'W'

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| countryCode |  | 3-character ISO-3166 (Alpha-3) country code.<br>*Example:* `"USA"` | Yes |
| currencyCode |  | 3-character ISO-4217 (Alpha-3) currency code <br>*Example:* `"USD"` | Yes |
| operatorName |  | This identifies the operator that has issued the account to the recipient and is going to receive and post the funds to the recipient’s wallet. (Refer to Visa Direct Endpoint Guide on list of supported Wallet Operators).  | Yes |
| accountIdentifier |  | The wallet recipient's actual account identifier associated with the wallet operator (e.g., wallet address - phone/email/username that identifies the account associated with the wallet operator)  | Yes |
| accountIdentifierType | <br>**Available values:** "PHONENUMBER", "EMAIL", "USERNAME" | The type of account identifier used by the recipient.   Supported values are PHONENUMBER, EMAIL and USERNAME. <br>*Enum:* `"PHONENUMBER"`, `"EMAIL"`, `"USERNAME"`<br>*Example:* `"PHONENUMBER"` | Yes |

#### EndToEndId-2 Schema

Identifier assigned by the Originating Entity's customer to track the transaction end-to-end

Conditional: Required if payout to a wallet recipient

ISO20022 field name: end-to-end identification 

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| EndToEndId-2 | string | Identifier assigned by the Originating Entity's customer to track the transaction end-to-end  Conditional: Required if payout to a wallet recipient  ISO20022 field name: end-to-end identification   |  |

**Example**
<pre>5003f6a02c4411b2aa5747378ae5331</pre>

#### BusinessApplicationId Schema

Business Application Identifier (BAI) identifies the type of program for which the payment is being sent, i.e. whether it is a funds disbursement, money transfer etc. It should be a valid value allowed by Visa and approved for the program during onboarding.

Valid BAI for Visa Direct Account & Wallet: 
- Money transfer: AA, PP, FT, WT; 
- Non-money transfer: BB, FD, GD, GP, LO, MD, OG, PD, BP, PS;

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| BusinessApplicationId |  | Business Application Identifier (BAI) identifies the type of program for which the payment is being sent, i.e. whether it is a funds disbursement, money transfer etc. It should be a valid value allowed by Visa and approved for the program during onboarding.  Valid BAI for Visa Direct Account & Wallet:  - Money transfer: AA, PP, FT, WT;  - Non-money transfer: BB, FD, GD, GP, LO, MD, OG, PD, BP, PS;  |  |

**Example**
<pre>PP</pre>

#### Wallet-1 Schema

Recipient's wallet object

Conditional object when payoutMethod has value 'W'

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| countryCode | string |  | Yes |
| currencyCode | string |  | Yes |
| operatorName | string | This identifies the operator that has issued the account to the recipient and is going to receive and post the funds to the recipient’s wallet. (Refer to Visa Direct Endpoint Guide on list of supported Wallet Operators).  | Yes |
| accountIdentifier | string | The wallet recipient's actual account identifier associated with the wallet operator (e.g., wallet address - phone/email/username that identifies the account associated with the wallet operator)  | Yes |
| accountIdentifierType | string, <br>**Available values:** "PHONENUMBER", "EMAIL", "USERNAME" | The type of account identifier used by the recipient.   Supported values are PHONENUMBER, EMAIL and USERNAME. <br>*Enum:* `"PHONENUMBER"`, `"EMAIL"`, `"USERNAME"`<br>*Example:* `"PHONENUMBER"` | Yes |

#### LimitReachedDetails Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| currencyCode |  | 3-character ISO-4217 (Alpha-3) currency code <br>*Example:* `"USD"` | Yes |
| flexibleAmountLimit | undefined (double) | Liquidity limit. | Yes |

#### 202TransactionStatus-1 Schema

- PENDING: Payout is accepted but has not been acknowledged

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| 202TransactionStatus-1 | string, <br>**Available values:** "PENDING" | - PENDING: Payout is accepted but has not been acknowledged  |  |

#### EODFlexibleSettlementNotification Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| accountId |  | The accountId uniquely identifies the account as a virtual account number(i.e. VAN), with a value or number assigned by Visa. | Yes |
| eventType | <br>**Available values:** "END_OF_DAY" | The type of event that triggered the notification.<br>*Enum:* `"END_OF_DAY"` | Yes |
| windowDueDetails |  |  | Yes |
| currentDueDetails |  |  | No |
| initiatingPartyId | undefined (int64) | Identifier assigned by Visa to uniquely identify the Originating Entity who initiates the transaction  ISO20022 field name: Initiating Party Identification<br> Visa uses integer instead of string(1-35) for uniformed value generation and presentation. <br>*Example:* `100111` | Yes |
| notificationDateTime | undefined (date-time) | ISO 8601 formatted UTC Timestamp, YYYY-MM-DDThh:mm:ss.sssTZD. TZD is either Z or +/-00:00  example: 2020-05-05T12:12:12.000Z, or 1997-07-16T19:20:30.45+00:00  ISO20022 field name: Transaction Information And Status - Message Creation Date Time  | Yes |

#### DigitalAssetRecipientIsCompany-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name |  | Recipient company name. <br>Must not contain exclusively numeric characters  ISO20022 field name: Creditor Name  | Yes |
| type | <br>**Available values:** "I", "C" | Identifies the type of recipient - "C" for Company   | Yes |
| address | { **"city"**: , **"state"**: , **"country"**: , **"postalCode"**: , **"addressLine1"**: , **"addressLine2"**:  } |  | Yes |
| identificationList |  | Identification list of recipient | Yes |

#### DigitalAssetRecipientIsCompany-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name | string | Recipient company name. <br>Must not contain exclusively numeric characters  ISO20022 field name: Creditor Name  | Yes |
| type | string, <br>**Available values:** "I", "C" | Identifies the type of recipient - "C" for Company   | Yes |
| address | { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string } |  | Yes |
| identificationList | [ { **"idType"**: string, <br>**Available values:** "T", "L", **"idNumber"**: string, **"idIssueCountry"**: string } ] |  | Yes |

#### FlexibleAmountUtilized-1 Schema

Amount of liquidity that has been utilized.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| FlexibleAmountUtilized-1 | double | Amount of liquidity that has been utilized. |  |

#### ClientReferenceId Schema

Identifier assigned by the Originating Entity to uniquely identify the transaction.

ISO20022 field name: Transaction Identification

Only alphanumeric and '-' characters are allowed.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| ClientReferenceId |  | Identifier assigned by the Originating Entity to uniquely identify the transaction.  ISO20022 field name: Transaction Identification  Only alphanumeric and '-' characters are allowed.  |  |

#### AccountQueryPendingResponse Schema

Transaction is accepted and will be processed & notified status.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"status"**: <br>**Available values:** "PENDING", **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64) } |  | No |

#### FlexibleAmountRemaining-1 Schema

Remaining amount of liquidity available.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| FlexibleAmountRemaining-1 | double | Remaining amount of liquidity available. |  |

#### TimestampType-1 Schema

ISO 8601 formatted UTC Timestamp, YYYY-MM-DDThh:mm:ss.sssTZD. TZD is either Z or +/-00:00

example: 2020-05-05T12:12:12.000Z, or 1997-07-16T19:20:30.45+00:00

ISO20022 field name: Transaction Information And Status - Message Creation Date Time

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TimestampType-1 | dateTime | ISO 8601 formatted UTC Timestamp, YYYY-MM-DDThh:mm:ss.sssTZD. TZD is either Z or +/-00:00  example: 2020-05-05T12:12:12.000Z, or 1997-07-16T19:20:30.45+00:00  ISO20022 field name: Transaction Information And Status - Message Creation Date Time  |  |

#### Date-1 Schema

a Date

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| Date-1 | date | a Date |  |

#### TransactionalAdditionalData-2 Schema

Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value)

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TransactionalAdditionalData-2 | [ { **"name"**: string, **"value"**: string } ] | Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value) |  |

#### DigitalAssetLedgerCurrencyCode Schema

The cryptocurrency or fiat currency code

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| DigitalAssetLedgerCurrencyCode | <br>**Available values:** "USDC", "PYUSD" | The cryptocurrency or fiat currency code |  |

**Example**
<pre>USDC</pre>

#### TransactionalAdditionalData-1 Schema

Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value)

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TransactionalAdditionalData-1 | [ { **"name"**: string, **"value"**: string } ] | Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value) |  |

#### AccountPayoutOnlyRequest-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"quoteId"**: long, **"endToEndId"**: string, **"paymentRail"**: string, <br>**Available values:** "SWIFT", **"payoutSpeed"**: string, <br>**Available values:** "STANDARD", "PREMIUM", **"fundingModel"**: string, <br>**Available values:** "PREFUNDED", **"additionalData"**: [ { **"name"**: string, **"value"**: string } ], **"purposeOfPayment"**: string, **"clientReferenceId"**: string, **"initiatingPartyId"**: long, **"transactionAmount"**: double, **"statementNarrative"**: string, **"senderSourceOfFunds"**: string, **"structuredRemittance"**: [ { **"amount"**: double, **"taxAmount"**: double, **"taxCurrencyCode"**: string, **"creditorReference"**: { **"code"**: string, <br>**Available values:** "RADM", "RPIN", "FXDR", "DISP", "PUOR", "SCOR", **"number"**: string }, **"amountCurrencyCode"**: string, **"referredDocumentInformation"**: [ { **"code"**: string, <br>**Available values:** "MSIN", "CNFA", "DNFA", "CINV", "CREN", "DEBN", "HIRI", "SBIN", "CMCN", "SOAC", "DISP", "BOLD", "VCHR", "AROI", "TSUT", "PUOR", **"number"**: string, **"relatedDate"**: date } ] } ], **"businessApplicationId"**: string, **"settlementCurrencyCode"**: string, **"transactionCurrencyCode"**: string, **"senderBeneficiaryRelationship"**: string } |  | Yes |

#### CompanySenderIdentificationListAccount-2 Schema

Identification list of sender

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| CompanySenderIdentificationListAccount-2 |  | Identification list of sender |  |

#### AccountPayoutOnlyRequest-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"quoteId"**: undefined (int64), **"endToEndId"**: , **"paymentRail"**: <br>**Available values:** "SWIFT", **"payoutSpeed"**: <br>**Available values:** "STANDARD", "PREMIUM", **"fundingModel"**: <br>**Available values:** "PREFUNDED", **"additionalData"**: , **"purposeOfPayment"**: , **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"statementNarrative"**: , **"senderSourceOfFunds"**: , **"structuredRemittance"**: , **"businessApplicationId"**: , **"settlementCurrencyCode"**: , **"transactionCurrencyCode"**: , **"senderBeneficiaryRelationship"**:  } |  | Yes |

#### DigitalAssetPayoutRequestAltered Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"senderSourceOfFunds"**: , **"businessApplicationId"**: , **"settlementCurrencyCode"**: , **"transactionCurrencyCode"**:  } |  | Yes |

#### CompanySenderIdentificationListAccount-1 Schema

Identification list of sender

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| CompanySenderIdentificationListAccount-1 | [ { **"idType"**: string, <br>**Available values:** "T", "L", "I", **"idNumber"**: string, **"idIssueCountry"**: string } ] | Identification list of sender |  |

#### ErrorResponse Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| reason |  | The short description of the error. | Yes |
| status |  | 3 digit HTTP status code<br>*Example:* `400` | Yes |
| details |  |  | Yes |
| message |  | The long description of the error | No |

#### IndividualSenderIdentificationListAccount Schema

Identification list of sender

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| IndividualSenderIdentificationListAccount |  | Identification list of sender |  |

#### AccountPayoutResponse-4 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| AccountPayoutResponse-4 | { **"transactionDetail"**: { **"status"**: string, <br>**Available values:** "PAYMENT_RECEIVED", **"payoutId"**: string, **"endToEndId"**: string, **"payoutSpeed"**: string, <br>**Available values:** "STANDARD", "PREMIUM", **"fxConversionRate"**: double, **"settlementAmount"**: double, **"clientReferenceId"**: string, **"destinationAmount"**: double, **"initiatingPartyId"**: long, **"transactionAmount"**: double, **"expectedPostingDate"**: undefined (date), **"transactionDateTime"**: dateTime, **"settlementCurrencyCode"**: string, **"destinationCurrencyCode"**: string, **"transactionCurrencyCode"**: string } } |  |  |

#### ValidateWalletTransactionDetail Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| quoteId | undefined (int64) | This is a unique FX quote ID generated by Visa for a payout currency pair. <br>*Example:* `987654321` | No |
| endToEndId |  | Identifier assigned by the Originating Entity's customer to track the transaction end-to-end  Conditional: Required if payout to a wallet recipient  ISO20022 field name: end-to-end identification <br>*Example:* `"5003f6a02c4411b2aa5747378ae5331"` | Yes |
| payoutSpeed | <br>**Available values:** "STANDARD", "PREMIUM" | Originating Entity to indicate the desired payout speed for the payment. Currently supported value is "STANDARD". This field will be enhanced in future to include additional speed options  ISO20022 field name: Instruction Priority <br>*Enum:* `"STANDARD"`, `"PREMIUM"`<br>*Example:* `"standard"` | No |
| fundingModel | <br>**Available values:** "PREFUNDED" | The fundingModel to apply to this payout.<br>*Enum:* `"PREFUNDED"` | No |
| additionalData |  | Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value) | No |
| purposeOfPayment |  | Purpose of payment is required in certain markets to clearly identify the purpose of the payment based on the standard values defined for respective market Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths) ISO20022 field name: Purpose of Payment  | No |
| initiatingPartyId | undefined (int64) |  | Yes |
| transactionAmount | undefined (double) | The amount to debit from merchant's funding account or credit to recipient's bank account. Note: Transaction amount can have decimal point for currencies that allow it. Refer to the Visa Direct Endpoint Guide for Payout on country-specific currency minor units.  Example: Currency exponent for USD is 2, the amount is $100.99. Currency exponent for JPY is 0. If the amount is JPY 10,000, then this field should populate “10000”. ISO20022 field name: Instructed Amount  | Yes |
| statementNarrative |  |  | No |
| senderSourceOfFunds |  | Sender source of funds indicator i.e. the funding method used by the sender to fund the payout.Valid values are: Conditional - source of funds is required by some endpoints, please check for Visa Payment Guide for details    01 = Visa credit 02 = Visa debit 03 = Visa prepaid 04 = Cash 05 = Deposit accounts other than those linked to a Visa card (includes checking/savings accounts and proprietary debit/ATMcards) 06 = Credit accounts other than those linked to a Visa card (includes credit cards and proprietary credit lines)  Note: For any Company to Company (C2C) or Company to Individual (C2I) use-case, this should be “05”, since the funds come from the sender’s bank account.  ISO20022 field name: Debtor Account Type  | No |
| businessApplicationId |  | Business Application Identifier (BAI) identifies the type of program for which the payment is being sent, i.e. whether it is a funds disbursement, money transfer etc. It should be a valid value allowed by Visa and approved for the program during onboarding.  Valid BAI for Visa Direct Account & Wallet:  - Money transfer: AA, PP, FT, WT;  - Non-money transfer: BB, FD, GD, GP, LO, MD, OG, PD, BP, PS; <br>*Example:* `"PP"` | Yes |
| settlementCurrencyCode |  | The settlement currency code The 3-character ISO-4217 code in this field reflects the currency for the Settlement amount to be debited from Originating Entity/Visa Client's funding account. Format: 3-character ISO-4217 (Alpha-3) currency code  <b>This field is mandatory</b>  Example: GBP  | No |
| transactionCurrencyCode |  | The 3-character ISO-4217 code in this field reflects the currency associated to the transaction amount.  Format: 3-character ISO-4217 (Alpha-3) currency code Example: PHP  | Yes |
| senderBeneficiaryRelationship |  | Sender's relationship with recipient | No |

#### AccountPayoutResponse-3 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| AccountPayoutResponse-3 | { **"transactionDetail"**: { **"status"**: string, <br>**Available values:** "PAYMENT_RECEIVED", **"payoutId"**: string, **"endToEndId"**: string, **"payoutSpeed"**: string, <br>**Available values:** "STANDARD", "PREMIUM", **"fxConversionRate"**: double, **"settlementAmount"**: double, **"clientReferenceId"**: string, **"destinationAmount"**: double, **"initiatingPartyId"**: long, **"transactionAmount"**: double, **"expectedPostingDate"**: undefined (date), **"transactionDateTime"**: dateTime, **"settlementCurrencyCode"**: string, **"destinationCurrencyCode"**: string, **"transactionCurrencyCode"**: string } } |  |  |

#### AccountPayoutResponse-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| AccountPayoutResponse-2 | { **"transactionDetail"**: { **"status"**: <br>**Available values:** "PAYMENT_RECEIVED", **"payoutId"**: , **"endToEndId"**: , **"payoutSpeed"**: <br>**Available values:** "STANDARD", "PREMIUM", **"fxConversionRate"**: undefined (double), **"settlementAmount"**: undefined (double), **"clientReferenceId"**: , **"destinationAmount"**: undefined (double), **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"expectedPostingDate"**: undefined (date), **"transactionDateTime"**: undefined (date-time), **"settlementCurrencyCode"**: , **"destinationCurrencyCode"**: , **"transactionCurrencyCode"**:  } } |  |  |

#### AccountPayoutResponse-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| AccountPayoutResponse-1 | { **"transactionDetail"**: { **"status"**: string, <br>**Available values:** "PAYMENT_RECEIVED", **"payoutId"**: string, **"endToEndId"**: string, **"payoutSpeed"**: string, <br>**Available values:** "STANDARD", "PREMIUM", **"fxConversionRate"**: double, **"settlementAmount"**: double, **"clientReferenceId"**: string, **"destinationAmount"**: double, **"initiatingPartyId"**: long, **"transactionAmount"**: double, **"expectedPostingDate"**: undefined (date), **"transactionDateTime"**: dateTime, **"settlementCurrencyCode"**: string, **"destinationCurrencyCode"**: string, **"transactionCurrencyCode"**: string } } |  |  |

#### ConversionRate Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| ConversionRate | undefined (double) |  |  |

**Example**
<pre>0.07</pre>

#### AccountSenderIsCompany-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name | string | Sender company name. <br>Must not contain exclusively numeric characters  ISO20022 field name:<br>For 4th party payments: "Ultimate Debtor Name"<br>For 3rd party payments: "Debtor Name"  | Yes |
| type | string, <br>**Available values:** "I", "C" | Identifies the type of sender - "C" for Company   | Yes |
| identificationList | [ { **"idType"**: string, <br>**Available values:** "T", "L", "I", **"idNumber"**: string, **"idIssueCountry"**: string } ] | Identification list of sender | No |

#### AccountSenderIsCompany-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name |  | Sender company name. <br>Must not contain exclusively numeric characters  ISO20022 field name:<br>For 4th party payments: "Ultimate Debtor Name"<br>For 3rd party payments: "Debtor Name"  | Yes |
| type | <br>**Available values:** "I", "C" | Identifies the type of sender - "C" for Company   | Yes |
| identificationList |  | Identification list of sender | No |

#### AccountPayoutRequest Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"quoteId"**: undefined (int64), **"endToEndId"**: , **"paymentRail"**: <br>**Available values:** "SWIFT", **"payoutSpeed"**: <br>**Available values:** "STANDARD", "PREMIUM", **"fundingModel"**: <br>**Available values:** "PREFUNDED", **"additionalData"**: , **"purposeOfPayment"**: , **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"statementNarrative"**: , **"senderSourceOfFunds"**: , **"structuredRemittance"**: , **"businessApplicationId"**: , **"settlementCurrencyCode"**: , **"transactionCurrencyCode"**: , **"senderBeneficiaryRelationship"**:  } |  | Yes |

#### CompanyIdTypeAccount Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| CompanyIdTypeAccount | <br>**Available values:** "T", "L", "I" |  |  |

#### ValidatePayoutDigitalAssetRequestAltered Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"senderSourceOfFunds"**: , **"businessApplicationId"**: , **"settlementCurrencyCode"**: , **"transactionCurrencyCode"**:  } |  | Yes |

#### DigitalAssetRecipientPayoutAddress Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| city |  | Recipient address city  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  ISO20022 field name: Creditor Address Town Name  | No |
| state |  | Recipient address state or province  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  ISO20022 field name: Creditor Address Country Sub-division  | No |
| country |  | Recipient address country  Format: 3-character ISO-3166 (Alpha-3) country code  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  ISO20022 field name: Creditor Address Country  | Yes |
| postalCode |  | Recipient address postal code  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  ISO20022 field name: Creditor Address Postal Code  | No |
| addressLine1 |  | Recipient address line 1  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  ISO20022 field name: Creditor Address Street Name  | No |
| addressLine2 |  | Recipient address line 2  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  ISO20022 field name: Creditor Address Floor  | No |

#### PayoutCancelStatus-1 Schema

Status of the cancel request

Valid Value are: PENDING_CANCELLATION, CANCELLED

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| PayoutCancelStatus-1 | string, <br>**Available values:** "PENDING_CANCELLATION", "CANCELLED" | Status of the cancel request  Valid Value are: PENDING_CANCELLATION, CANCELLED  |  |

**Example**
<pre>CANCELLED</pre>

#### DigitalAssetQueryPendingCancelledResponse-2 Schema

Transaction is in pending or cancelled (cancelled during pending) status.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | <br>**Available values:** "D" | This field indicates the payout method i.e. Digital Asset Valid values: - "D" Visa Direct Digital Asset <br>*Enum:* `"D"` | No |
| transactionDetail | { **"status"**: <br>**Available values:** "PENDING", "PENDING_CANCELLATION", "CANCELLED", **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64) } |  | Yes |

#### IdentityGroup-1 Schema

This type defines a recipient identity data group. Each group is normally represented as a section of fields on the UI. 'groupLabel' is the UI test to display as a name for this section. 'mandatory' indicates whether all section is mandatory. 'elementName' is the name of the element in the request for the corresponding section.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| groupName | string, <br>**Available values:** "bank", "address", "name", "additionalData", "identificationList", "legalEntityIdentity", "contactInfo", "birthInfo" | The name of the metadata element/enum. This generic Identity Group object can represent either 'Recipient Identity Field Group object' or 'Bank Account Registration Field Group object' .  Enum value signifies the particular metadata element.   For example :   a) if enum is "address", this can contain array of 'IdentityField' object where each object can represent elements like addressLine1, addressLine2, city, countryCode, postalCode etc       b) enum can be "identificationList", which contains array of "IdentityField' objects, one of the IdentityField object can have elementName="idType" and inputType="list", in this scenario array of IdentityListItem will have   [    {      "label": "Passport",      "value": "Passport"    },    {      "label": "National ID Card",      "value": "National ID Card"    },    {      "label": "Driving License",      "value": "Driving License"    }  ],   second 'IdentityField' Object -> elementName as "identificationNumber" with inputType="text"   third 'IdentityField' Object -> elementName as "identificationCountry" with inputType="text"   fourth 'IdentityField' Object -> elementName as "validFromDate" with inputType="text"  fifth  'IdentityField' Object -> elementName as "validToDate" with inputType="text" and so on.   c) If enum is "additionalData",this will have array of two 'IdentityField' objects, one representing 'additionalDataKey' and other one 'additionalDataValue'.   d) If enum is "name", "middleName" may be required for some countries (e.g. Africa). This can be accommodated by appending a space and then middleName to <firstName> <br>*Enum:* `"bank"`, `"address"`, `"name"`, `"additionalData"`, `"identificationList"`, `"legalEntityIdentity"`, `"contactInfo"`, `"birthInfo"` | Yes |
| mandatory | boolean | Indicates if the identity group is mandatory. | Yes |
| groupLabel | string | Displays a label for this group of identity fields. | Yes |
| identityFields | [ { **"locale"**: string, **"maxSize"**: integer, **"subTitle"**: string, **"tabOrder"**: integer, **"inputType"**: string, <br>**Available values:** "text", "date", "number", "list", **"listItems"**: [ { **"label"**: string, **"value"**: string } ], **"mandatory"**: boolean, **"separator"**: string, **"description"**: string, **"displaySize"**: integer, **"elementName"**: string, **"valueRegexp"**: string } ] | This type defines a list of recipient identity fields. | Yes |

#### IdNumber Schema

In this field, the identification number (from the document type identified in the field recipientDetail.idType) should be provided.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| IdNumber |  | In this field, the identification number (from the document type identified in the field recipientDetail.idType) should be provided. |  |

**Example**
<pre>1234567890</pre>

#### ValidatePayoutWalletRequest-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"quoteId"**: long, **"endToEndId"**: string, **"payoutSpeed"**: string, <br>**Available values:** "STANDARD", "PREMIUM", **"fundingModel"**: string, <br>**Available values:** "PREFUNDED", **"additionalData"**: [ { **"name"**: string, **"value"**: string } ], **"purposeOfPayment"**: string, **"initiatingPartyId"**: long, **"transactionAmount"**: double, **"statementNarrative"**: string, **"senderSourceOfFunds"**: string, **"businessApplicationId"**: string, **"settlementCurrencyCode"**: string, **"transactionCurrencyCode"**: string, **"senderBeneficiaryRelationship"**: string } |  | Yes |

#### IdentityGroup-3 Schema

This type defines a recipient identity data group. Each group is normally represented as a section of fields on the UI. 'groupLabel' is the UI test to display as a name for this section. 'mandatory' indicates whether all section is mandatory. 'elementName' is the name of the element in the request for the corresponding section.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| groupName | string, <br>**Available values:** "bank", "address", "name", "additionalData", "identificationList", "legalEntityIdentity", "contactInfo", "birthInfo" | The name of the metadata element/enum. This generic Identity Group object can represent either 'Recipient Identity Field Group object' or 'Bank Account Registration Field Group object' .  Enum value signifies the particular metadata element.   For example :   a) if enum is "address", this can contain array of 'IdentityField' object where each object can represent elements like addressLine1, addressLine2, city, countryCode, postalCode etc       b) enum can be "identificationList", which contains array of "IdentityField' objects, one of the IdentityField object can have elementName="idType" and inputType="list", in this scenario array of IdentityListItem will have   [    {      "label": "Passport",      "value": "Passport"    },    {      "label": "National ID Card",      "value": "National ID Card"    },    {      "label": "Driving License",      "value": "Driving License"    }  ],   second 'IdentityField' Object -> elementName as "identificationNumber" with inputType="text"   third 'IdentityField' Object -> elementName as "identificationCountry" with inputType="text"   fourth 'IdentityField' Object -> elementName as "validFromDate" with inputType="text"  fifth  'IdentityField' Object -> elementName as "validToDate" with inputType="text" and so on.   c) If enum is "additionalData",this will have array of two 'IdentityField' objects, one representing 'additionalDataKey' and other one 'additionalDataValue'.   d) If enum is "name", "middleName" may be required for some countries (e.g. Africa). This can be accommodated by appending a space and then middleName to <firstName>  <br>*Enum:* `"bank"`, `"address"`, `"name"`, `"additionalData"`, `"identificationList"`, `"legalEntityIdentity"`, `"contactInfo"`, `"birthInfo"` | Yes |
| mandatory | boolean | Indicates if the identity group is mandatory. | Yes |
| groupLabel | string | Displays a label for this group of identity fields. | Yes |
| identityFields | [ { **"locale"**: string, **"maxSize"**: integer, **"subTitle"**: string, **"tabOrder"**: integer, **"inputType"**: string, <br>**Available values:** "text", "date", "number", "list", **"listItems"**: [ { **"label"**: string, **"value"**: string } ], **"mandatory"**: boolean, **"separator"**: string, **"description"**: string, **"displaySize"**: integer, **"elementName"**: string, **"valueRegexp"**: string } ] | This type defines a list of recipient identity fields. | Yes |

#### ValidatePayoutWalletRequest-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| transactionDetail | { **"quoteId"**: undefined (int64), **"endToEndId"**: , **"payoutSpeed"**: <br>**Available values:** "STANDARD", "PREMIUM", **"fundingModel"**: <br>**Available values:** "PREFUNDED", **"additionalData"**: , **"purposeOfPayment"**: , **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"statementNarrative"**: , **"senderSourceOfFunds"**: , **"businessApplicationId"**: , **"settlementCurrencyCode"**: , **"transactionCurrencyCode"**: , **"senderBeneficiaryRelationship"**:  } |  | Yes |

#### IdentityGroup-2 Schema

This type defines a recipient identity data group. Each group is normally represented as a section of fields on the UI. 'groupLabel' is the UI test to display as a name for this section. 'mandatory' indicates whether all section is mandatory. 'elementName' is the name of the element in the request for the corresponding section.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| groupName | string, <br>**Available values:** "bank", "address", "name", "additionalData", "identificationList", "legalEntityIdentity", "contactInfo", "birthInfo" | The name of the metadata element/enum. This generic Identity Group object can represent either 'Beneficiary Identity Field Group object' or 'Bank Account Registration Field Group object' .  Enum value signifies the particular metadata element.   For example :   a) if enum is "address", this can contain array of 'IdentityField' object where each object can represent elements like addressLine1, addressLine2, city, countryCode, postalCode etc       b) enum can be "identificationList", which contains array of "IdentityField' objects, one of the IdentityField object can have elementName="idType" and inputType="list", in this scenario array of IdentityListItem will have   [    {      "label": "Passport",      "value": "Passport"    },    {      "label": "National ID Card",      "value": "National ID Card"    },    {      "label": "Driving License",      "value": "Driving License"    }  ],   second 'IdentityField' Object -> elementName as "identificationNumber" with inputType="text"   third 'IdentityField' Object -> elementName as "identificationCountry" with inputType="text"   fourth 'IdentityField' Object -> elementName as "validFromDate" with inputType="text"  fifth  'IdentityField' Object -> elementName as "validToDate" with inputType="text" and so on.   c) If enum is "additionalData",this will have array of two 'IdentityField' objects, one representing 'additionalDataKey' and other one 'additionalDataValue'.   d) If enum is "name", "middleName" may be required for some countries (e.g. Africa). This can be accommodated by appending a space and then middleName to <firstName>  <br>*Enum:* `"bank"`, `"address"`, `"name"`, `"additionalData"`, `"identificationList"`, `"legalEntityIdentity"`, `"contactInfo"`, `"birthInfo"` | Yes |
| mandatory | boolean | Indicates if the identity group is mandatory. | Yes |
| groupLabel | string | Displays a label for this group of identity fields. | Yes |
| identityFields | [ { **"locale"**: string, **"maxSize"**: integer, **"subTitle"**: string, **"tabOrder"**: integer, **"inputType"**: string, <br>**Available values:** "text", "date", "number", "list", **"listItems"**: [ { **"label"**: string, **"value"**: string } ], **"mandatory"**: boolean, **"separator"**: string, **"description"**: string, **"displaySize"**: integer, **"elementName"**: string, **"valueRegexp"**: string } ] | This type defines a list of recipient identity fields. | Yes |

#### ExpectedPostingDate-1 Schema

This is an estimated date by which the payout should be posted to the recipient’s account. This date should be communicated to the sender and recipient (if possible) to ensure that they know when to expect the funds

It is optional field, if exists, indicates expected posting date change

ISO20022 field name: Interbank Settlement Date

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| ExpectedPostingDate-1 | undefined (date) | This is an estimated date by which the payout should be posted to the recipient’s account. This date should be communicated to the sender and recipient (if possible) to ensure that they know when to expect the funds  It is optional field, if exists, indicates expected posting date change  ISO20022 field name: Interbank Settlement Date  |  |

**Example**
<pre>1980-02-01</pre>

#### RecipientIndividual-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name | string | Full name of recipient is conditionally required when "firstName" and "lastName" are not provided.<br>Must not contain exclusively numeric characters<br>Must not contain special symbols <table>  <tr>  <td>!</td>  <td>"</td>  <td>£</td>  <td>$</td>  <td>%</td>  <td>^</td>  <td>*</td>  <td>+</td>  <td>=</td>  <td>¬</td>  <td>¦</td>  <td>:</td>  <td>;</td>  <td>@</td>  <td>~</td>  </tr>  </table><br>*Example:* `"Joe Smith"` | No |
| type | string, <br>**Available values:** "I", "C" | Identifies the type of recipient - "I" for Individual   | Yes |
| address | { **"city"**: string, **"state"**: string, **"country"**: string, **"postalCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string } |  | No |
| lastName | string | Recipient last name<br>Recipient first name and last name are conditionally required when "name" is not provided. The length of first name and last name combined must be at least 3 characters.<br>Must not contain exclusively numeric characters<br>Must not contain special symbols <table>  <tr>  <td>!</td>  <td>"</td>  <td>£</td>  <td>$</td>  <td>%</td>  <td>^</td>  <td>*</td>  <td>+</td>  <td>=</td>  <td>¬</td>  <td>¦</td>  <td>:</td>  <td>;</td>  <td>@</td>  <td>~</td>  </tr>  </table>  ISO20022 field name: Creditor Name  | No |
| firstName | string | Recipient first name<br>Recipient first name and last name are conditionally required when "name" is not provided. The length of first name and last name combined must be at least 3 characters.<br>Must not contain exclusively numeric characters<br>Must not contain special symbols <table>  <tr>  <td>!</td>  <td>"</td>  <td>£</td>  <td>$</td>  <td>%</td>  <td>^</td>  <td>*</td>  <td>+</td>  <td>=</td>  <td>¬</td>  <td>¦</td>  <td>:</td>  <td>;</td>  <td>@</td>  <td>~</td>  </tr>  </table>  ISO20022 field name: Creditor Name  | No |
| cityOfBirth | string | Recipient city of birth  ISO20022 field name: Creditor City of Birth  | No |
| dateOfBirth | date | Recipient date of birth (Format: "YYYY-MM-DD", e.g. "1980-02-01")  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  ISO20022 field name: Creditor Birth Date  | No |
| countryOfBirth | string | Recipient country of birth  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  Format: 3-character ISO-3166 (Alpha-3) country code  ISO20022 field name: Creditor Country of Birth  | No |

#### PayoutNotificationFailedRequest-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | string, <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. Account or Wallet  Valid values: - "B" Visa Direct Account - "W" Visa Direct Wallet <br>*Enum:* `"B"`, `"W"` | No |
| transactionDetail | { **"status"**: string, **"errorResponses"**: [ { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"code"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } ], **"clientReferenceId"**: string, **"initiatingPartyId"**: long, **"notificationDateTime"**: dateTime } |  | Yes |

#### ExpectedPostingDate-2 Schema

This is an estimated date by which the payout should be posted to the recipient’s account. This date should be communicated to the sender and recipient (if possible) to ensure that they know when to expect the funds.

ISO20022 field name: Interbank Settlement Date

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| ExpectedPostingDate-2 | undefined (date) | This is an estimated date by which the payout should be posted to the recipient’s account. This date should be communicated to the sender and recipient (if possible) to ensure that they know when to expect the funds.  ISO20022 field name: Interbank Settlement Date  |  |

**Example**
<pre>1980-02-01</pre>

#### ExpectedPostingDate-3 Schema

This is an estimated date by which the payout should be posted to the recipient’s account. This date should be communicated to the sender and recipient (if possible) to ensure that they know when to expect the funds

ISO20022 field name: Transaction Information And Status - Effective Interbank Settlement Date

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| ExpectedPostingDate-3 | undefined (date) | This is an estimated date by which the payout should be posted to the recipient’s account. This date should be communicated to the sender and recipient (if possible) to ensure that they know when to expect the funds  ISO20022 field name: Transaction Information And Status - Effective Interbank Settlement Date  |  |

**Example**
<pre>1980-02-01</pre>

#### SignedAmount Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| SignedAmount | undefined (double) |  |  |

**Example**
<pre>12.34</pre>

#### DigitalAssetCurrencyCode-1 Schema

The cryptocurrency or fiat currency code

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| DigitalAssetCurrencyCode-1 | string, <br>**Available values:** "USDC" | The cryptocurrency or fiat currency code |  |

**Example**
<pre>USDC</pre>

#### WalletQueryOnlyResponse Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| WalletQueryOnlyResponse | { **"payoutMethod"**: <br>**Available values:** "W", **"transactionDetail"**: { **"status"**: <br>**Available values:** "PAYMENT_RECEIVED", "AWAITING_INFORMATION", "PAYMENT_SENT", "PAYMENT_DELIVERED", "PENDING_CANCELLATION", "CANCELLED", "RETURNED", "REJECTED", "DELIVERED_TO_SCHEME", "DELIVERED_TO_RECIPIENT_BANK", **"payoutId"**: , **"endToEndId"**: , **"payoutSpeed"**: <br>**Available values:** "STANDARD", "PREMIUM", **"fundingModel"**: <br>**Available values:** "PREFUNDED", **"returnAmount"**: undefined (double), **"fundingStatus"**: <br>**Available values:** "FUNDED", "NOT_FUNDED", "FUNDED_AGING", **"serviceDetail"**: { **"traceable"**: , **"recallable"**: , **"paymentRail"**: <br>**Available values:** "ACH", "RTP", "RTGS", "SWIFT", **"isFinalStatus"**:  }, **"returnDateTime"**: undefined (date-time), **"returnPayoutId"**: , **"fxConversionRate"**: undefined (double), **"settlementAmount"**: undefined (double), **"clientReferenceId"**: , **"deliveredDateTime"**: undefined (date-time), **"destinationAmount"**: undefined (double), **"initiatingPartyId"**: undefined (int64), **"transactionAmount"**: undefined (double), **"returnCurrencyCode"**: , **"returnSourceAmount"**: undefined (double), **"expectedPostingDate"**: undefined (date), **"returnReasonDetails"**: { **"code"**: , **"description"**:  }, **"transactionDateTime"**: undefined (date-time), **"returnConversionRate"**: undefined (double), **"settlementCurrencyCode"**: , **"destinationCurrencyCode"**: , **"transactionCurrencyCode"**: , **"walletAdditionalDetails"**: { **"shareLink"**:  }, **"localSchemeTransactionId"**: , **"returnSourceCurrencyCode"**:  } } or { **"payoutMethod"**: <br>**Available values:** "W", **"transactionDetail"**: { **"status"**: <br>**Available values:** "VALIDATION_FAILED", "ERROR", **"errorDetails"**:  } } or { **"payoutMethod"**: <br>**Available values:** "B", "W", **"transactionDetail"**: { **"status"**: <br>**Available values:** "PENDING", "PENDING_CANCELLATION", "CANCELLED", **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64) } } |  |  |

#### RecipientDetailMetadata Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| identityGroups |  |  | Yes |

#### PayoutNotificationRequestStatus-1 Schema

Status of the transaction being queried

ISO20022 field name: Transaction Status

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| PayoutNotificationRequestStatus-1 | string | Status of the transaction being queried  ISO20022 field name: Transaction Status  |  |

#### AccountQueryPendingOnlyCancelledResponse Schema

Transaction is in pending or cancelled (cancelled during pending) status.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | <br>**Available values:** "B", "W" | Originating Entity must indicate the payout method i.e. Account or Wallet  Valid values: - "B" Visa Direct Account - "W" Visa Direct Wallet <br>*Enum:* `"B"`, `"W"` | No |
| transactionDetail | { **"status"**: <br>**Available values:** "PENDING", "PENDING_CANCELLATION", "CANCELLED", **"clientReferenceId"**: , **"initiatingPartyId"**: undefined (int64) } |  | Yes |

#### AccountQueryOnlyErrorResponse-1 Schema

Transaction is accepted and will be processed & notified status.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| payoutMethod | string, <br>**Available values:** "B" | Originating Entity must indicate the payout method i.e. To Account    Valid values: “B” – Visa Direct Account <br>*Enum:* `"B"` | No |
| transactionDetail | { **"status"**: string, <br>**Available values:** "VALIDATION_FAILED", "ERROR", **"errorDetails"**: [ { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"code"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } ] } |  | Yes |

#### BankName-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| BankName-1 | string |  |  |

**Example**
<pre>Bank of America</pre>

#### AccountTransactionDetail-4 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| quoteId | long | This is a unique FX quote ID generated by Visa for a payout currency pair.          <br>*Example:* `987654321` | No |
| endToEndId | string | Identifier assigned by the Originating Entity's customer to track the transaction end-to-end  Conditional: Required if payout to a wallet recipient  ISO20022 field name: end-to-end identification  <br>*Example:* `"5003f6a02c4411b2aa5747378ae5331"` | No |
| payoutSpeed | string, <br>**Available values:** "STANDARD", "PREMIUM" | Originating Entity to indicate the desired payout speed for the payment. Currently supported value is "STANDARD". This field will be enhanced in future to include additional speed options  ISO20022 field name: Instruction Priority <br>*Enum:* `"STANDARD"`, `"PREMIUM"`<br>*Example:* `"standard"` | No |
| additionalData | [ { **"name"**: string, **"value"**: string } ] | Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value) | No |
| purposeOfPayment | string | Purpose of payment is required in certain markets to clearly identify the purpose of the payment based on the standard values defined for respective market Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths) ISO20022 field name: Purpose of Payment  | No |
| clientReferenceId | string | Identifier assigned by the Originating Entity to uniquely identify the transaction.  ISO20022 field name: Transaction Identification  Only alphanumeric and '-' characters are allowed.  | Yes |
| initiatingPartyId | long |  | Yes |
| transactionAmount | double | The amount to debit from merchant's funding account or credit to recipient's bank account. Note: Transaction amount can have decimal point for currencies that allow it. Refer to the Visa Direct Endpoint Guide for Payout on country-specific currency minor units.  Example: Currency exponent for USD is 2, the amount is $100.99. Currency exponent for JPY is 0. If the amount is JPY 10,000, then this field should populate “10000”. ISO20022 field name: Instructed Amount  | Yes |
| statementNarrative | string |  | No |
| senderSourceOfFunds | string | Sender source of funds indicator i.e. the funding method used by the sender to fund the payout.Valid values are: Conditional - source of funds is required by some endpoints, please check for Visa Payment Guide for details    01 = Visa credit 02 = Visa debit 03 = Visa prepaid 04 = Cash 05 = Deposit accounts other than those linked to a Visa card (includes checking/savings accounts and proprietary debit/ATMcards) 06 = Credit accounts other than those linked to a Visa card (includes credit cards and proprietary credit lines)  Note: For any Company to Company (C2C) or Company to Individual (C2I) use-case, this should be “05”, since the funds come from the sender’s bank account. This field is required for Money Transfers and Funds Disbursements.  ISO20022 field name: Debtor Account Type  | No |
| structuredRemittance | [ { **"amount"**: double, **"taxAmount"**: double, **"taxCurrencyCode"**: string, **"creditorReference"**: { **"code"**: string, <br>**Available values:** "RADM", "RPIN", "FXDR", "DISP", "PUOR", "SCOR", **"number"**: string }, **"amountCurrencyCode"**: string, **"referredDocumentInformation"**: [ { **"code"**: string, <br>**Available values:** "MSIN", "CNFA", "DNFA", "CINV", "CREN", "DEBN", "HIRI", "SBIN", "CMCN", "SOAC", "DISP", "BOLD", "VCHR", "AROI", "TSUT", "PUOR", **"number"**: string, **"relatedDate"**: date } ] } ] | This object carries ISO20022 SMI data. It applies to Visa Direct Account payouts only.  | No |
| businessApplicationId | string | Business Application Identifier (BAI) identifies the type of program for which the payment is being sent, i.e. whether it is a funds disbursement, money transfer etc. It should be a valid value allowed by Visa and approved for the program during onboarding.  Valid BAI for Visa Direct Account & Wallet:  - Money transfer: AA, PP, FT, WT;  - Non-money transfer: BB, FD, GD, GP, LO, MD, OG, PD, BP; <br>*Example:* `"PP"` | Yes |
| settlementCurrencyCode | string | The settlement currency code The 3-character ISO-4217 code in this field reflects the currency for the Settlement amount to be debited from Originating Entity/Visa Client's funding account. Format: 3-character ISO-4217 (Alpha-3) currency code  <b>This field is mandatory</b>  Example: GBP  | No |
| transactionCurrencyCode | string | The 3-character ISO-4217 code in this field reflects the currency associated to the transaction amount.  Format: 3-character ISO-4217 (Alpha-3) currency code Example: PHP  | Yes |
| senderBeneficiaryRelationship | string | Sender's relationship with recipient | No |

#### AccountTransactionDetail-3 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| quoteId | long | This is a unique FX quote ID generated by Visa for a payout currency pair.          <br>*Example:* `987654321` | No |
| endToEndId | string | Identifier assigned by the Originating Entity's customer to track the transaction end-to-end  Conditional: Required if payout to a wallet recipient  ISO20022 field name: end-to-end identification  <br>*Example:* `"5003f6a02c4411b2aa5747378ae5331"` | No |
| payoutSpeed | string, <br>**Available values:** "STANDARD", "PREMIUM" | Originating Entity to indicate the desired payout speed for the payment. Currently supported value is "STANDARD". This field will be enhanced in future to include additional speed options  ISO20022 field name: Instruction Priority <br>*Enum:* `"STANDARD"`, `"PREMIUM"`<br>*Example:* `"standard"` | No |
| additionalData | [ { **"name"**: string, **"value"**: string } ] | Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value) | No |
| purposeOfPayment | string | Purpose of payment is required in certain markets to clearly identify the purpose of the payment based on the standard values defined for respective market Conditional (Refer to Payouts Endpoint Guide on country-specific required fields and lengths) ISO20022 field name: Purpose of Payment  | No |
| clientReferenceId | string | Identifier assigned by the Originating Entity to uniquely identify the transaction.  ISO20022 field name: Transaction Information And Status - Original Transaction Identification  Only alphanumeric and '-' characters are allowed.  | Yes |
| initiatingPartyId | long |  | Yes |
| transactionAmount | double | The amount to debit from merchant's funding account or credit to beneficiary's bank account. Note: Transaction amount can have decimal point for currencies that allow it. Refer to the Payouts Endpoint Guide for Payout on country-specific currency minor units.  Example: Currency exponent for USD is 2, the amount is $100.99. Currency exponent for JPY is 0. If the amount is JPY 10,000, then this field should populate “10000”. ISO20022 field name: Instructed Amount  | Yes |
| statementNarrative | string |  | No |
| senderSourceOfFunds | string | Sender source of funds indicator i.e. the funding method used by the sender to fund the payout.Valid values are: Conditional - source of funds is required by some endpoints, please check for Visa Payment Guide for details    01 = Visa credit 02 = Visa debit 03 = Visa prepaid 04 = Cash 05 = Deposit accounts other than those linked to a Visa card (includes checking/savings accounts and proprietary debit/ATMcards) 06 = Credit accounts other than those linked to a Visa card (includes credit cards and proprietary credit lines)  Note: For any Company to Company (C2C) or Company to Individual (C2I) use-case, this should be “05”, since the funds come from the sender’s bank account. This field is required for Money Transfers and Funds Disbursements.  ISO20022 field name: Debtor Account Type Source of Funds  | No |
| businessApplicationId | string | Business Application Identifier (BAI) identifies the type of program for which the payment is being sent, i.e. whether it is a funds disbursement, money transfer etc. It should be a valid value allowed by Visa and approved for the program during onboarding.  Valid BAI for Visa Direct Account & Wallet:  - Money transfer: AA, PP;  - Non-money transfer: BB, FD, GD, GP, LO, MD, OG, PD, BP; <br>*Example:* `"PP"` | Yes |
| settlementCurrencyCode | string | The settlement currency code The 3-character ISO-4217 code in this field reflects the currency for the Settlement amount to be debited from Originating Entity/Visa Client's funding account. Format: 3-character ISO-4217 (Alpha-3) currency code  <b>This field is mandatory</b>  Example: GBP  | No |
| transactionCurrencyCode | string | The 3-character ISO-4217 code in this field reflects the currency associated to the transaction amount.  Format: 3-character ISO-4217 (Alpha-3) currency code Example: PHP  | Yes |
| senderBeneficiaryRelationship | string | Sender's relationship with recipient | No |

#### AccountSenderTypeIsUnspecified-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| name |  | Sender name. Full name is conditionally required when "firstName" and "lastName" are not provided. <br>Must have at least 3 chars<br>Must not contain exclusively numeric characters<br>Must not contain special symbols<br><table>  <tr>  <td>!</td><td>"</td><td>£</td>  <td>$</td>  <td>%</td>  <td>^</td>  <td>*</td>  <td>+</td>  <td>=</td>  <td>¬</td>  <td>¦</td>  <td>:</td>  <td>;</td>  <td>@</td>  <td>~</td>  </tr>  </table>  ISO20022 field name:<br>For 4th party payments: "Ultimate Debtor Name" <br>For 3rd party payments: "Debtor Name"      | No |
| type | <br>**Available values:** "U" | Identifies the type of sender - "U" for Unspecified(whether Individual or Company). <br>*Enum:* `"U"` | Yes |
| cityOfBirth |  | Sender city of birth  ISO20022 field name:<br>For 4th party payments: "Ultimate Debtor City of Birth" <br>For 3rd party payments: "Debtor City of Birth"  | No |
| dateOfBirth | undefined (date) | Sender date of birth (Format: "YYYY-MM-DD", e.g. "1980-02-01")  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  ISO20022 field name:<br>For 4th party payments: "Ultimate Debtor Birth Date" <br>For 3rd party payments: "Debtor Birth Date"  | No |
| countryOfBirth |  | Sender country of birth  Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths)  Format: 3-character ISO-3166 (Alpha-3) country code  ISO20022 field name:<br>For 4th party payments: "Ultimate Debtor Country of Birth" <br>For 3rd party payments: "Debtor Country of Birth"  | No |
| identificationList |  | Identification list of sender | No |

#### AccountTransactionDetail-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| quoteId | undefined (int64) | This is a unique FX quote ID generated by Visa for a payout currency pair. <br>*Example:* `987654321` | No |
| endToEndId |  | Identifier assigned by the Originating Entity's customer to track the transaction end-to-end  Conditional: Required if payout to a wallet recipient  ISO20022 field name: end-to-end identification <br>*Example:* `"5003f6a02c4411b2aa5747378ae5331"` | No |
| paymentRail | <br>**Available values:** "SWIFT" | Indicates the payment rails preferred for the payout transaction.<br>*Enum:* `"SWIFT"`<br>*Example:* `"SWIFT"` | No |
| payoutSpeed | <br>**Available values:** "STANDARD", "PREMIUM" | Originating Entity to indicate the desired payout speed for the payment. Currently supported value is "STANDARD". This field will be enhanced in future to include additional speed options  ISO20022 field name: Instruction Priority <br>*Enum:* `"STANDARD"`, `"PREMIUM"`<br>*Example:* `"STANDARD"` | No |
| fundingModel | <br>**Available values:** "PREFUNDED" | The fundingModel to apply to this payout.<br>*Enum:* `"PREFUNDED"` | No |
| additionalData |  | Additional fields that are needed in order to complete the additional screening. The additional fields can be included as name value pairs (Field name, Field value) | No |
| purposeOfPayment |  | Purpose of payment is required in certain markets to clearly identify the purpose of the payment based on the standard values defined for respective market Conditional (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths) ISO20022 field name: Purpose of Payment  | No |
| clientReferenceId |  | Identifier assigned by the Originating Entity to uniquely identify the transaction.  ISO20022 field name: Transaction Identification  Only alphanumeric and '-' characters are allowed.  | Yes |
| initiatingPartyId | undefined (int64) | Identifier assigned by Visa to uniquely identify the Originating Entity who initiates the transaction  ISO20022 field name: Initiating Party Identification<br> Visa uses integer instead of string(1-35) for uniformed value generation and presentation. <br>*Example:* `100111` | Yes |
| transactionAmount | undefined (double) | The amount to debit from merchant's funding account or credit to recipient's bank account. Note: Transaction amount can have decimal point for currencies that allow it. Refer to the Visa Direct Endpoint Guide for Payout on country-specific currency minor units.  Example: Currency exponent for USD is 2, the amount is $100.99. Currency exponent for JPY is 0. If the amount is JPY 10,000, then this field should populate “10000”. ISO20022 field name: Instructed Amount  | Yes |
| statementNarrative |  | Originating Entity is advised to provide a narrative that helps the recipient clearly identify the sender and reason for the payment. Text will be displayed on the recipient’s statement when the payment gets posted to the recipient’s account or wallet statement.  Not all wallet operators support a statement narrative.  Conditional - (Refer to Visa Direct Endpoint Guide on country-specific required fields and lengths).  ISO20022 field name: Remittance Information Unstructured <br>*Example:* `"testing narrative"` | No |
| senderSourceOfFunds |  | Sender source of funds indicator i.e. the funding method used by the sender to fund the payout.Valid values are: Conditional - source of funds is required by some endpoints, please check for Visa Payment Guide for details    01 = Visa credit 02 = Visa debit 03 = Visa prepaid 04 = Cash 05 = Deposit accounts other than those linked to a Visa card (includes checking/savings accounts and proprietary debit/ATMcards) 06 = Credit accounts other than those linked to a Visa card (includes credit cards and proprietary credit lines)  Note: For any Company to Company (C2C) or Company to Individual (C2I) use-case, this should be “05”, since the funds come from the sender’s bank account.  ISO20022 field name: Debtor Account Type  | No |
| structuredRemittance |  | This object carries ISO20022 SMI data. It applies to Visa Direct Account payouts only.  | No |
| businessApplicationId |  | Business Application Identifier (BAI) identifies the type of program for which the payment is being sent, i.e. whether it is a funds disbursement, money transfer etc. It should be a valid value allowed by Visa and approved for the program during onboarding.  Valid BAI for Visa Direct Account & Wallet:  - Money transfer: AA, PP, FT, WT;  - Non-money transfer: BB, FD, GD, GP, LO, MD, OG, PD, BP, PS; <br>*Example:* `"PP"` | Yes |
| settlementCurrencyCode |  | The settlement currency code The 3-character ISO-4217 code in this field reflects the currency for the Settlement amount to be debited from Originating Entity/Visa Client's funding account. Format: 3-character ISO-4217 (Alpha-3) currency code  <b>This field is mandatory</b>  Example: GBP  | No |
| transactionCurrencyCode |  | The 3-character ISO-4217 code in this field reflects the currency associated to the transaction amount.  Format: 3-character ISO-4217 (Alpha-3) currency code Example: PHP  | Yes |
| senderBeneficiaryRelationship |  | Sender's relationship with recipient | No |

#### ContactNumber Schema

Contact phone number
+ symbol followed by digits, no other symbols, e.g. +447700123456 
(note, refer ISO spec E.164)

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| ContactNumber |  | Contact phone number + symbol followed by digits, no other symbols, e.g. +447700123456  (note, refer ISO spec E.164)  |  |

[...]
